//+------------------------------------------------------------------+
//|                                           updateCustomSymbol.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <socket-library-mt4-mt5.mqh>
string symbol_custom="access";

int OnInit()
  {
   EventSetMillisecondTimer(1);

//---
   return(INIT_SUCCEEDED);
  }

void OnTimer()
  {
   EventKillTimer();

   ClientSocket*glbSocket;

   glbSocket=new ClientSocket("127.0.0.1",9999);
   if(!glbSocket.IsSocketConnected())
     {
  
      Print(GetLastError());
     }
   if(glbSocket.IsSocketConnected())
     {
      glbSocket.Send("e");
      Sleep(20);
      string output=glbSocket.Receive(); 

      MqlDateTime running,current; 
      MqlTick ticks_array[2];
      MqlRates rates_add[2], previous_rates[1];
      
      int Should_change=0; 

      string split_input_to_rateTicks[]; 
      
      int store=StringSplit(output,',',split_input_to_rateTicks);

        datetime Time_For_Rates = (datetime)(int(split_input_to_rateTicks[0]));
      TimeToStruct((datetime)(int(split_input_to_rateTicks[1])),running);
      TimeToStruct(Time_For_Rates,current);
      
      if(current.min + 1 == running.min)
      {
      Should_change = 1;
      running.min = running.min-1;
   if(running.min <0) {running.min=59;running.hour=running.hour-1;}
   if(running.hour < 0) {running.hour = 23;}
      }
      else
       {running.min = running.min+1;
   if(running.min > 59) {running.min=0;running.hour=running.hour+1;}
   if(running.hour > 23) {running.hour = 0;}}
         Comment(Time_For_Rates, "  ", StructToTime(running));      
      ticks_array[Should_change].time= StructToTime(running);
      ticks_array[Should_change].bid = NormalizeDouble(double(split_input_to_rateTicks[7]),_Digits);
      ticks_array[Should_change].ask = NormalizeDouble(double(split_input_to_rateTicks[8]),_Digits);
      ticks_array[Should_change].last = NormalizeDouble(double(split_input_to_rateTicks[5]),_Digits);
      ticks_array[Should_change].flags= TICK_FLAG_LAST;
      ticks_array[Should_change].time_msc = 0; 
      CustomTicksAdd(symbol_custom,ticks_array);
       
      rates_add[Should_change].time = Time_For_Rates;
      rates_add[Should_change].open = NormalizeDouble(double(split_input_to_rateTicks[2]),_Digits);
      rates_add[Should_change].high= NormalizeDouble(double(split_input_to_rateTicks[3]),_Digits);
      rates_add[Should_change].low = NormalizeDouble(double(split_input_to_rateTicks[4]),_Digits);
      rates_add[Should_change].close=NormalizeDouble(double(split_input_to_rateTicks[5]),_Digits);
      rates_add[0].spread=(int)((double(split_input_to_rateTicks[8])-double(split_input_to_rateTicks[7]))*pow(10,_Digits-1));
      rates_add[0].tick_volume=int(split_input_to_rateTicks[6]);
      rates_add[0].real_volume=0;  

      Print(CustomRatesReplace(symbol_custom,Time_For_Rates,Time_For_Rates,rates_add));
      
     
ArrayPrint(split_input_to_rateTicks);
Print( rates_add[Should_change].open,"  ", rates_add[Should_change].high
,"  ", rates_add[Should_change].low,"  ", rates_add[Should_change].close
,"  ",SymbolInfoDouble(symbol_custom,SYMBOL_LAST));
Print(split_input_to_rateTicks[2],"  ",split_input_to_rateTicks[3],"  ",split_input_to_rateTicks[4],"  ",split_input_to_rateTicks[5]
,"  ",SymbolInfoDouble(symbol_custom,SYMBOL_LAST), "  ",SymbolInfoInteger(symbol_custom,SYMBOL_DIGITS));
     }
   delete glbSocket;

   EventSetMillisecondTimer(1);


  }
//+------------------------------------------------------------------+
